//+------------------------------------------------------------------+
//|                                                        bb EA.mq4 |
//|                               Copyright  2010, Nondisclosure007 |
//|                                               http://no.link.yet |
//+------------------------------------------------------------------+

#property copyright "Copyright  2010, Nondisclosure007"
#property link      "http://no.link.yet"

#include <OrderReliable.mqh>

extern bool      varStopEA   =false;
extern int       bbPeriod     =          10;
extern int       bbDeviation  =           2;
extern int       bbPrice      =           0;
extern int       bblookback   =         100; 
extern double    varTakeProfit=0;//Symbols w/ 5 decimal places.
extern double    varBWmin     =          20;
extern bool      varUseMM=false;
extern double    varLot=1.0;
extern double    varRiskBig=4.0;
extern double    varRiskSmall=1.0;
extern int       varSlippage=30;
extern double    varAcctCap=1000000000; //1MM
extern double    varSpreadProtect=1000;
extern int       varTime=24;

double varOrderMagicNumber,varAcctBalance;
string varOrderComment;
int handle;

int init()
  {
   varOrderMagicNumber=funcGenerateMagicNumber(Period());
   if (varOrderMagicNumber==0) 
   {
      varStopEA=true; 
	   Alert("The EA will not Operate due to the Symbol() not being found in the funcSymbol2Val function");
	   return(0);
   }
   varOrderComment=StringConcatenate(Symbol()," ",funcTimeFrame_Val2String(Period())); 
   string filename="voltilitytest.csv"; //StringConcatenate(Symbol(),Period(),".csv");
   handle=FileOpen(filename,FILE_CSV|FILE_READ|FILE_WRITE,',');
   FileWrite(handle,"order Number","Type","Slope");
   return(0);
  }

  
int deinit()
  {

  
   return(0);
  }

  
int start()
  {
   if (varStopEA==true) {return(0);}//emergency EA stop for a pair
   int varOrdersTotal=OrdersTotal(); //used for ceiling stuff.
   double varAcctBalance=MathMin(AccountBalance(),MathMin(AccountEquity(),AccountFreeMargin()));     
   if (varOrdersTotal==0 && varAcctBalance>=varAcctCap) {return(0);} //no orders and we've reached our pre-set cap.
   bool varNewBar=funcIsNewBar(Period());
   if (varNewBar)
   {
//====== work current open orders ==================
//---- this work order section has to move outside of NewBar when Fibo Extension is enabled --------
      int symbolorder=0;
      bool varNoOrder=true;
      for (int i=0; i<OrdersTotal(); i++)
      {//1 +cycle by orders search
         if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
         if (OrderMagicNumber()!=varOrderMagicNumber) continue;
         int varOrderType=OrderType(); 
         varNoOrder=funcOrderWork(varOrderType);
         if (!varNoOrder) {procMoveSL(varOrderType);}
         //varNoOrder=false;  
      }
//====== done w/ work current open order ===========  
      if (varNoOrder) {procOpenOrder();}  
   }
   return(0);
  }

void procOpenOrder()
{
   double varOTrend=funcOpenTrend(); int ticket;
	double varSL=iSAR(NULL,0,0.02,0.2,1), varTP=0;
	string type;
   if (varUseMM) 
   {
       varLot=funcGetLots(varAcctBalance,varRiskBig);
   }
   if (varOTrend==1) 
   {
     if (varTakeProfit>0) {varTP=Bid+(varTakeProfit*Point);}
     ticket=OrderSendReliable(Symbol(),OP_BUY,varLot,Ask,0,0,0,varOrderComment,varOrderMagicNumber,0,Blue);
     type="Long";
   }        
   if (varOTrend==-1)
   {
     if (varTakeProfit>0) {varTP=Ask-(varTakeProfit*Point);}
     ticket=OrderSendReliable(Symbol(),OP_SELL,varLot,Bid,0,0,0,varOrderComment,varOrderMagicNumber,0,Red);
     type="Short";
   }
   if (ticket>0)
   {
      double varSlope=iCustom(NULL,0,"LR - Least Squares - Slope",4,8,0,1);
      FileWrite(handle,ticket,type,varSlope);
      modifyOrder(varTP,varSL,ticket);
   }
}

void modifyOrder(double TP, double SL, int ticket)
{
   if (ticket>0)
   {
      OrderSelect(ticket,SELECT_BY_TICKET);
      OrderModifyReliable(OrderTicket(),OrderOpenPrice(),SL,TP,0,Green);
   } 
}
double funcOpenTrend()
{
   bool varTimeOK=funcCheckTime();
   double varSpread=MarketInfo(Symbol(),MODE_SPREAD);
   double varBandwidthLast=iCustom(NULL,0,"bb - Bandwidth",bbPeriod,bbDeviation,bbPrice,bblookback,0,2);
   double varBandwidthMaxLast=iCustom(NULL,0,"bb - Bandwidth",bbPeriod,bbDeviation,bbPrice,bblookback,2,2);
   double varBandwidthCurrent=iCustom(NULL,0,"bb - Bandwidth",bbPeriod,bbDeviation,bbPrice,bblookback,0,1);   
   double varBandwidthMaxCurrent=iCustom(NULL,0,"bb - Bandwidth",bbPeriod,bbDeviation,bbPrice,bblookback,2,1);
   double varBandwidthWindowCurrent=iCustom(NULL,0,"bb BW Window",bbPeriod,bbDeviation,bbPrice,bblookback,0,1);
   double varPercB=iCustom(NULL,0,"bb - Percent b",bbPeriod,bbDeviation,bbPrice,0,1);
   double varSar=iSAR(NULL,0,0.02,0.2,1);
   if (varBandwidthLast<varBandwidthMaxLast && 
       varBandwidthLast<varBandwidthCurrent &&
       varBandwidthCurrent>varBandwidthMaxCurrent &&
       varTimeOK)
   {
      if (varPercB>50.0 &&
          varSar<Low[1] &&
          varSpread<varSpreadProtect)
          {return(1);}
      if (varPercB<50.0 &&
          varSar>High[1] && 
          varSpread<varSpreadProtect)
          {return(-1);}
   }
   
   return(0);
}

bool funcCheckTime()
{
   //see Forex Trading and Probabilites for Times to trade.
   bool varTimeDistance=false, varTimeHourOK=false, varReturnTime=false;
   datetime curtime=Time[0];
   datetime lasttime=Time[varTime];
   double PeriodSeconds=varTime*Period()*60;
   if ((curtime-lasttime)<=PeriodSeconds) {varTimeDistance=true;}
   int thehour=TimeHour(curtime);
   if (thehour>6 && thehour<22) {varTimeHourOK=true;}
   if (varTimeHourOK && varTimeDistance) {varReturnTime=true;}
   return(varTimeDistance);  
   return(varReturnTime);
}

bool funcOrderWork(int varOrderType)
{
	//move SL if possible.
	bool varNoOrderTemp=false; string type;
	//double varSlope=iCustom(NULL,0,"LR - Least Squares - Slope",5,4,0,0,1);
   double varBandwidthLast=iCustom(NULL,0,"bb - Bandwidth",bbPeriod,bbDeviation,bbPrice,bblookback,0,2);
   double varBandwidthCurrent=iCustom(NULL,0,"bb - Bandwidth",bbPeriod,bbDeviation,bbPrice,bblookback,0,1);   
   if (varBandwidthCurrent<varBandwidthLast)
   {
      if (varOrderType==OP_BUY){type="Long"; varNoOrderTemp=OrderCloseReliable(OrderTicket(),OrderLots(),Bid,varSlippage,Yellow);}
      if (varOrderType==OP_SELL){type="Short"; varNoOrderTemp=OrderCloseReliable(OrderTicket(),OrderLots(),Ask,varSlippage,Yellow);} 
   }
   return(varNoOrderTemp);      
}

void procMoveSL(int varOrderType)
{//old code snargled from http://www.metatrader.info/node/116
   double varSL=iSAR(NULL,0,0.02,0.2,1);
   if (MathAbs(varSL-OrderStopLoss())>MarketInfo(Symbol(),MODE_STOPLEVEL)*Point)  
   {
     if(varOrderType==OP_BUY)
     {
         if (varSL<Low[1] && 
             varSL<Open[0] && 
             (varSL>OrderStopLoss() || OrderStopLoss()==0.0))
            {OrderModifyReliable(OrderTicket(),OrderOpenPrice(),varSL,OrderTakeProfit(),0,Green);}
     }
     if(varOrderType==OP_SELL)
     {
         if (varSL>High[1] && 
             varSL>Open[0] && 
             (varSL<OrderStopLoss() || OrderStopLoss()==0.0))
            {OrderModifyReliable(OrderTicket(),OrderOpenPrice(),varSL,OrderTakeProfit(),0,Red);}
     }
  }
}

//======================== Support functions that are set in stone =====================================

double funcGetLots(double varAcctBalance, double varRisk)
{
   if (varRisk==varRiskBig) {return(0.4);}
   if (varRisk==varRiskSmall) {return(0.1);}
/*   if (!varUseMM) {return(varLot);}
   double varMinLot=MarketInfo(Symbol(),MODE_MINLOT);
   double varMaxLot=MarketInfo(Symbol(),MODE_MAXLOT);
   double varLots=NormalizeDouble((varAcctBalance*(varRisk/100))*AccountLeverage()/MarketInfo(Symbol(),MODE_LOTSIZE),2);
   if (varLots>varMaxLot) return(varMaxLot);
   if (varLots<varMinLot) return(0);
   return(varLots);
*/
}

int funcGenerateMagicNumber(int vartempTimeframe)
{
   int vartempTimeframeval=funcTimeFrame_Const2Val(vartempTimeframe);
   int vartempSymbol=funcSymbol2Val(Symbol());
   if (vartempSymbol==00) {return(vartempSymbol);}
   return(vartempTimeframeval+vartempSymbol);    
}

bool funcIsNewBar(int timeFrame)
   {
   bool res=false;
   
   // the array contains open time of the current (zero) bar
   // for 7 (seven) timeframes
   static datetime _sTime[7];  
   int i=6;
   //Note: i below will be 6 or timeframe will be day.
   switch (timeFrame) 
      {
      case 1  : i=0; break;
      case 5  : i=2; break;
      case 15 : i=3; break;
      case 30 : i=4; break;
      case 60 : i=5; break;
      case 240: break;
      case 1440:break;
      default:  timeFrame = 1440;
      }
//----
   if (_sTime[i]==0 || _sTime[i]!=iTime(Symbol(),timeFrame,0))
      {
      _sTime[i] = iTime(Symbol(),timeFrame,0);
      res=true;
      }
      
//----
   return(res);   
   }

//+------------------------------------------------------------------+
//| Time frame interval appropriation  function                      |
//+------------------------------------------------------------------+
int funcTimeFrame_Const2Val(int varConstant) 
{
   switch(varConstant) 
   {
      case 1:  
         return(1000);
      case 5:  
         return(2000);
      case 15:
         return(3000);
      case 30:
         return(4000);
      case 60:
         return(5000);
      case 240:
         return(6000);
      case 1440:
         return(7000);
      case 10080:
         return(8000);
      case 43200:
         return(9000);
   }
}
//+------------------------------------------------------------------+
//| Time frame string appropriation  function                               |
//+------------------------------------------------------------------+
string funcTimeFrame_Val2String(int varValue) 
{
   switch(varValue) 
   {
      case 1:  
         return("PERIOD_M1");
      case 2:  
         return("PERIOD_M5");
      case 3:
         return("PERIOD_M15");
      case 4:
         return("PERIOD_M30");
      case 5:
         return("PERIOD_H1");
      case 6:
         return("PERIOD_H4");
      case 7:
         return("PERIOD_D1");
      case 8:
         return("PERIOD_W1");
      case 9:
         return("PERIOD_MN1");
   	default: 
   		return("undefined " +varValue);
   }
}
int funcSymbol2Val(string varSymbol) 
{
   string varMySymbol = StringSubstr(varSymbol,0,6);
	if(varMySymbol=="AUDCAD" || varMySymbol=="AUDCADm") return(1);
	if(varMySymbol=="AUDJPY" || varMySymbol=="AUDJPYm") return(2);
	if(varMySymbol=="AUDNZD" || varMySymbol=="AUDNZDm") return(3);
	if(varMySymbol=="AUDUSD" || varMySymbol=="AUDUSDm") return(4);
	if(varMySymbol=="CHFJPY" || varMySymbol=="CHFJPYm") return(5);
	if(varMySymbol=="EURAUD" || varMySymbol=="EURAUDm") return(6);
	if(varMySymbol=="EURCAD" || varMySymbol=="EURCADm") return(7);
	if(varMySymbol=="EURCHF" || varMySymbol=="EURCHFm") return(8);
	if(varMySymbol=="EURGBP" || varMySymbol=="EURGBPm") return(9);
	if(varMySymbol=="EURJPY" || varMySymbol=="EURJPYm") return(10);
	if(varMySymbol=="EURUSD" || varMySymbol=="EURUSDm") return(11);
	if(varMySymbol=="GBPCHF" || varMySymbol=="GBPCHFm") return(12);
	if(varMySymbol=="GBPJPY" || varMySymbol=="GBPJPYm") return(13);
	if(varMySymbol=="GBPUSD" || varMySymbol=="GBPUSDm") return(14);
	if(varMySymbol=="NZDUSD" || varMySymbol=="NZDUSDm") return(15);
	if(varMySymbol=="USDCAD" || varMySymbol=="USDCADm") return(16);
	if(varMySymbol=="USDCHF" || varMySymbol=="USDCHFm") return(17);
	if(varMySymbol=="USDJPY" || varMySymbol=="USDJPYm") return(18);
	if(varMySymbol=="NZDJPY" || varMySymbol=="NZDJPYm") return(19);
	if(varMySymbol=="AUDCHF" || varMySymbol=="AUDCHFm") return(20);	
	if(varMySymbol=="EURNZD" || varMySymbol=="EURNZDm") return(21);
	if(varMySymbol=="GBPNZD" || varMySymbol=="GBPNZDm") return(22);	
	if(varMySymbol=="NZDCHF" || varMySymbol=="NZDCHFm") return(23);	
	if(varMySymbol=="USDGSD" || varMySymbol=="USDGSDm") return(24);	
	if(varMySymbol=="USDZAR" || varMySymbol=="USDZARm") return(25);
	if(varMySymbol=="USDMXN" || varMySymbol=="USDMXNm") return(26);	
	return(00);
}


